diff --git a/SHADE_Engine/src/Editor/EditorWindow/HierarchyPanel/SHHierarchyPanel.cpp b/SHADE_Engine/src/Editor/EditorWindow/HierarchyPanel/SHHierarchyPanel.cpp
index 27e46d98..f2f8d927 100644
--- a/SHADE_Engine/src/Editor/EditorWindow/HierarchyPanel/SHHierarchyPanel.cpp
+++ b/SHADE_Engine/src/Editor/EditorWindow/HierarchyPanel/SHHierarchyPanel.cpp
@@ -93,8 +93,7 @@ namespace SHADE
   {
     if (ImGui::BeginMenuBar())
     {
-      
-      ImGui::SetCursorPosX(ImGui::GetContentRegionAvail().x - 35.0f);
+      ImGui::SetCursorPosX(ImGui::GetContentRegionAvail().x * 0.75f);
       if(ImGui::SmallButton(ICON_MD_DESELECT))
       {
         auto editor = SHSystemManager::GetSystem<SHEditor>();
diff --git a/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorComponentView.hpp b/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorComponentView.hpp
index 08f5695b..7fa39d74 100644
--- a/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorComponentView.hpp
+++ b/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorComponentView.hpp
@@ -39,6 +39,10 @@ namespace SHADE
       {
         SHComponentManager::RemoveComponent<T>(component->GetEID());
       }
+      if (ImGui::Selectable(std::format("{} Reset {}", ICON_MD_RESTART_ALT, componentName.data()).data()))
+      {
+        *component = T();
+      }
       ImGui::EndPopup();
     }
   }
@@ -48,7 +52,7 @@ namespace SHADE
     if (!component)
       return;
     const auto componentType = rttr::type::get(*component);
-    SHEditorWidgets::CheckBox("##IsActive", [component]() {return component->isActive; }, [component](bool const& active) {component->isActive = active; });
+    SHEditorWidgets::CheckBox("##IsActive", [component]() {return component->isActive; }, [component](bool const& active) {component->isActive = active; }, "Is Component Active");
     ImGui::SameLine();
     if (ImGui::CollapsingHeader(componentType.get_name().data()))
     {
@@ -89,7 +93,7 @@ namespace SHADE
             auto metaMax = property.get_metadata(META::max);
             if (metaMin && metaMax)
             {
-              SHEditorWidgets::SliderInt(property.get_name().data(), metaMin.template get_value<int>(), metaMin.template get_value<int>(), [component, property] {return property.get_value(component).to_int(); }, [component, property](int const& result) {property.set_value(component, result); });
+              SHEditorWidgets::SliderInt(property.get_name().data(), metaMin.template get_value<int>(), metaMax.template get_value<int>(), [component, property] {return property.get_value(component).to_int(); }, [component, property](int const& result) {property.set_value(component, result); });
             }
             else
             {
@@ -115,7 +119,7 @@ namespace SHADE
             auto metaMax = property.get_metadata(META::max);
             if (metaMin.is_valid() && metaMax.is_valid())
             {
-              SHEditorWidgets::SliderScalar<uint16_t>(property.get_name().data(), ImGuiDataType_U16, metaMin.template get_value<uint16_t>(), metaMin.template get_value<uint16_t>(), [component, property] {return property.get_value(component).to_uint16(); }, [component, property](uint16_t const& result) {property.set_value(component, result); }, "%zu");
+              SHEditorWidgets::SliderScalar<uint16_t>(property.get_name().data(), ImGuiDataType_U16, metaMin.template get_value<uint16_t>(), metaMax.template get_value<uint16_t>(), [component, property] {return property.get_value(component).to_uint16(); }, [component, property](uint16_t const& result) {property.set_value(component, result); }, "%zu");
             }
             else
             {
@@ -128,7 +132,7 @@ namespace SHADE
             auto metaMax = property.get_metadata(META::max);
             if (metaMin.is_valid() && metaMax.is_valid())
             {
-              SHEditorWidgets::SliderScalar<uint32_t>(property.get_name().data(), ImGuiDataType_U32, metaMin.template get_value<uint32_t>(), metaMin.template get_value<uint32_t>(), [component, property] { return property.get_value(component).to_uint32(); }, [component, property](uint32_t const& result) {property.set_value(component, result); }, "%zu");
+              SHEditorWidgets::SliderScalar<uint32_t>(property.get_name().data(), ImGuiDataType_U32, metaMin.template get_value<uint32_t>(), metaMax.template get_value<uint32_t>(), [component, property] { return property.get_value(component).to_uint32(); }, [component, property](uint32_t const& result) {property.set_value(component, result); }, "%zu");
             }
             else
             {
@@ -141,7 +145,7 @@ namespace SHADE
             auto metaMax = property.get_metadata(META::max);
             if (metaMin.is_valid() && metaMax.is_valid())
             {
-              SHEditorWidgets::SliderScalar<uint64_t>(property.get_name().data(), ImGuiDataType_U64, metaMin.template get_value<uint64_t>(), metaMin.template get_value<uint64_t>(), [component, property] {return property.get_value(component).to_uint64(); }, [component, property](uint64_t const& result) {property.set_value(component, result); }, "%zu");
+              SHEditorWidgets::SliderScalar<uint64_t>(property.get_name().data(), ImGuiDataType_U64, metaMin.template get_value<uint64_t>(), metaMax.template get_value<uint64_t>(), [component, property] {return property.get_value(component).to_uint64(); }, [component, property](uint64_t const& result) {property.set_value(component, result); }, "%zu");
             }
             else
             {
@@ -152,13 +156,18 @@ namespace SHADE
           {
             auto metaMin = property.get_metadata(META::min);
             auto metaMax = property.get_metadata(META::max);
+            float min{}, max{};
+            if(metaMin.is_valid())
+              min = std::max(metaMin.template get_value<float>(), -FLT_MAX * 0.5f);
+            if(metaMax.is_valid())
+              max = std::min(metaMax.template get_value<float>(), FLT_MAX * 0.5f);
             if (metaMin.is_valid() && metaMax.is_valid())
             {
-              SHEditorWidgets::SliderFloat(property.get_name().data(), metaMin.template get_value<float>(), metaMin.template get_value<float>(), [component, property] {return property.get_value(component).to_float(); }, [component, property](float const& result) {property.set_value(component, result); });
+              SHEditorWidgets::SliderFloat(property.get_name().data(), min, max, [component, property] {return property.get_value(component).to_float(); }, [component, property](float const& result) {property.set_value(component, result); });
             }
             else
             {
-              SHEditorWidgets::DragFloat(property.get_name().data(), [component, property] {return property.get_value(component).to_float(); }, [component, property](float const& result) {property.set_value(component, result); });
+              SHEditorWidgets::DragFloat(property.get_name().data(), [component, property] {return property.get_value(component).to_float(); }, [component, property](float const& result) {property.set_value(component, result); }, "Test");
             }
           }
           else if (type == rttr::type::get<double>())
@@ -167,7 +176,7 @@ namespace SHADE
             auto metaMax = property.get_metadata(META::max);
             if (metaMin.is_valid() && metaMax.is_valid())
             {
-              SHEditorWidgets::SliderScalar<double>(property.get_name().data(), ImGuiDataType_Double, metaMin.template get_value<double>(), metaMin.template get_value<double>(), [component, property] {return property.get_value(component).to_double(); }, [component, property](double const& result) {property.set_value(component, result); });
+              SHEditorWidgets::SliderScalar<double>(property.get_name().data(), ImGuiDataType_Double, metaMin.template get_value<double>(), metaMax.template get_value<double>(), [component, property] {return property.get_value(component).to_double(); }, [component, property](double const& result) {property.set_value(component, result); });
             }
             else
             {
diff --git a/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorInspector.cpp b/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorInspector.cpp
index b59ce9cc..d9b235e5 100644
--- a/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorInspector.cpp
+++ b/SHADE_Engine/src/Editor/EditorWindow/Inspector/SHEditorInspector.cpp
@@ -35,6 +35,23 @@ namespace SHADE
     return selected;
   }
 
+  template <typename ComponentType, typename EnforcedComponent, std::enable_if_t<std::is_base_of_v<SHComponent, ComponentType>, bool> = true, std::enable_if_t<std::is_base_of_v<SHComponent, EnforcedComponent>, bool> = true>
+  bool DrawAddComponentWithEnforcedComponentButton(EntityID const& eid)
+  {
+    bool selected = false;
+    if (!SHComponentManager::HasComponent<ComponentType>(eid))
+    {
+      if(selected = ImGui::Selectable(std::format("Add {}", rttr::type::get<ComponentType>().get_name().data()).data()); selected)
+      {
+        if(SHComponentManager::GetComponent_s<EnforcedComponent>(eid) == nullptr)
+          SHComponentManager::AddComponent<EnforcedComponent>(eid);
+
+        SHComponentManager::AddComponent<ComponentType>(eid);
+      }
+    }
+    return selected;
+  }
+
   SHEditorInspector::SHEditorInspector()
     :SHEditorWindow("Inspector", ImGuiWindowFlags_MenuBar)
   {
@@ -84,21 +101,19 @@ namespace SHADE
         }
         ImGui::Separator();
         // Render Scripts
-		    SHScriptEngine* scriptEngine = static_cast<SHScriptEngine*>(SHSystemManager::GetSystem<SHScriptEngine>());
-		    scriptEngine->RenderScriptsInInspector(eid);
+        SHScriptEngine* scriptEngine = static_cast<SHScriptEngine*>(SHSystemManager::GetSystem<SHScriptEngine>());
+        scriptEngine->RenderScriptsInInspector(eid);
         ImGui::Separator();
         if(ImGui::BeginMenu(std::format("{} Add Component", ICON_MD_LIBRARY_ADD).data()))
         {
           DrawAddComponentButton<SHTransformComponent>(eid);
-          DrawAddComponentButton<SHRenderable>(eid);
-          DrawAddComponentButton<SHColliderComponent>(eid);
-          if(DrawAddComponentButton<SHRigidBodyComponent>(eid))
-          {
-            if(SHComponentManager::GetComponent_s<SHTransformComponent>(eid) == nullptr)
-            {
-              SHComponentManager::AddComponent<SHTransformComponent>(eid);
-            }
-          }
+
+          // Components that require Transforms
+
+          DrawAddComponentWithEnforcedComponentButton<SHRenderable, SHTransformComponent>(eid);
+          DrawAddComponentWithEnforcedComponentButton<SHRigidBodyComponent, SHTransformComponent>(eid);
+          DrawAddComponentWithEnforcedComponentButton<SHColliderComponent, SHTransformComponent>(eid);
+
           ImGui::EndMenu();
         }
 
diff --git a/SHADE_Engine/src/Editor/EditorWindow/SHEditorWindowIncludes.h b/SHADE_Engine/src/Editor/EditorWindow/SHEditorWindowIncludes.h
index f0267b06..5208c6d9 100644
--- a/SHADE_Engine/src/Editor/EditorWindow/SHEditorWindowIncludes.h
+++ b/SHADE_Engine/src/Editor/EditorWindow/SHEditorWindowIncludes.h
@@ -3,4 +3,5 @@
 #include "HierarchyPanel/SHHierarchyPanel.h"  //Hierarchy Panel
 #include "Inspector/SHEditorInspector.h"      //Inspector
 #include "Profiling/SHEditorProfiler.h"       //Profiler
-#include "ViewportWindow/SHEditorViewport.h"  //Editor Viewport
\ No newline at end of file
+#include "ViewportWindow/SHEditorViewport.h"  //Editor Viewport
+#include "AssetBrowser/SHAssetBrowser.h"      //Asset Browser
\ No newline at end of file
diff --git a/SHADE_Engine/src/Editor/EditorWindow/ViewportWindow/SHEditorViewport.cpp b/SHADE_Engine/src/Editor/EditorWindow/ViewportWindow/SHEditorViewport.cpp
index b06c37c7..f5170999 100644
--- a/SHADE_Engine/src/Editor/EditorWindow/ViewportWindow/SHEditorViewport.cpp
+++ b/SHADE_Engine/src/Editor/EditorWindow/ViewportWindow/SHEditorViewport.cpp
@@ -24,12 +24,13 @@ namespace SHADE
   void SHEditorViewport::Init()
   {
     SHEditorWindow::Init();
-
+    transformGizmo.Init();
   }
 
   void SHEditorViewport::Update()
   {
     SHEditorWindow::Update();
+    ImGui::PushStyleVar(ImGuiStyleVar_WindowPadding, ImVec2(0.0f,0.0f));
     if(Begin())
     {
       ImGuizmo::SetDrawlist();
@@ -55,7 +56,7 @@ namespace SHADE
     ImGuizmo::SetRect(beginCursorPos.x , beginCursorPos.y, beginContentRegionAvailable.x, beginContentRegionAvailable.y);
     transformGizmo.Draw();
     ImGui::End();
-
+    ImGui::PopStyleVar();
   }
 
   void SHEditorViewport::Exit()
diff --git a/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.cpp b/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.cpp
index a53b8c10..3c984051 100644
--- a/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.cpp
+++ b/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.cpp
@@ -13,6 +13,12 @@
 #include "Editor/EditorWindow/ViewportWindow/SHEditorViewport.h"
 namespace SHADE
 {
+  void SHTransformGizmo::Init()
+  {
+    auto& style = ImGuizmo::GetStyle();
+    style.RotationLineThickness = 2.5f;
+  }
+
   void SHTransformGizmo::Draw()
   {
     bool justChangedTfm = false;
@@ -26,9 +32,12 @@ namespace SHADE
 
     SHMatrix view = SHMatrix::Transpose(editorCamera->GetViewMatrix());
     SHMatrix proj = SHMatrix::Transpose(editorCamera->GetProjMatrix());
+
+    //Invert projection y-axis
     proj(1, 1) *= -1;
+
     static SHMatrix gridMat = SHMatrix::Translate(0, -0.5f, 0.f) * SHMatrix::Identity;
-    //ImGuizmo::DrawGrid(&view._11, &proj._11, &gridMat._11, 100.f);
+
     if (selectedEntityTransformComponent == nullptr)
     {
       SHEditor* editor = SHSystemManager::GetSystem<SHEditor>();
@@ -55,31 +64,37 @@ namespace SHADE
       return;
 
     SHMatrix mat = selectedEntityTransformComponent->GetTRS();
-    isManipulating = ImGuizmo::Manipulate(&view._11, &proj._11, static_cast<ImGuizmo::OPERATION>(operation), ImGuizmo::MODE::WORLD, &mat._11);
-    if (!justChangedTfm)
+    useSnap = ImGui::IsKeyDown(ImGuiKey_LeftCtrl);
+    if(useSnap)
     {
-      if (ImGui::IsItemClicked())
-        SHCommandManager::PerformCommand(std::reinterpret_pointer_cast<SHBaseCommand>(std::make_shared<SHCommand<SHMatrix>>(selectedEntityTransformComponent->GetTRS(), mat, [tfm = std::move(selectedEntityTransformComponent)](SHMatrix const& mtx)
-          {
-            if (!tfm)
-              return;
-            SHVec3 translate{}, rotate{}, scale{};
-            mtx.Decompose(translate, rotate, scale);
-            tfm->SetWorldPosition(translate);
-            tfm->SetWorldRotation(rotate);
-            tfm->SetWorldScale(scale);
-          })));
-      else if (ImGui::IsItemHovered(ImGuiMouseButton_Left) && ImGui::IsMouseDown(ImGuiMouseButton_Left) && isManipulating)
-        SHCommandManager::PerformCommand(std::reinterpret_pointer_cast<SHBaseCommand>(std::make_shared<SHCommand<SHMatrix>>(selectedEntityTransformComponent->GetTRS(), mat, [tfm = std::move(selectedEntityTransformComponent)](SHMatrix const& mtx)
-          {
-            if (!tfm)
-              return;
-            SHVec3 translate{}, rotate{}, scale{};
-            mtx.Decompose(translate, rotate, scale);
-            tfm->SetWorldPosition(translate);
-            tfm->SetWorldRotation(rotate);
-            tfm->SetWorldScale(scale);
-          })), true);
+      switch (operation)
+      {
+      case Operation::TRANSLATE: snap = &translationSnap.x; break;
+      case Operation::ROTATE: snap = &rotationSnap; break;
+      case Operation::SCALE: snap = &scaleSnap; break;
+      default: snap = &translationSnap.x;
+      }
     }
+    ImGuizmo::Manipulate(&view._11, &proj._11, static_cast<ImGuizmo::OPERATION>(operation), ImGuizmo::MODE::WORLD, &mat._11, nullptr, useSnap ? snap : nullptr);
+    static bool startRecording = false;
+    if (!justChangedTfm && ImGuizmo::IsUsing())
+    {
+      
+        SHCommandManager::PerformCommand(std::reinterpret_pointer_cast<SHBaseCommand>(std::make_shared<SHCommand<SHMatrix>>(selectedEntityTransformComponent->GetTRS(), mat, [tfm = (selectedEntityTransformComponent)](SHMatrix const& mtx)
+          {
+            if (!tfm)
+              return;
+            SHVec3 translate{}, rotate{}, scale{};
+            mtx.Decompose(translate, rotate, scale);
+            tfm->SetWorldPosition(translate);
+            tfm->SetWorldRotation(rotate);
+            tfm->SetWorldScale(scale);
+          })), startRecording);
+      if(!startRecording)
+        startRecording = true;
+    }
+    isManipulating = ImGuizmo::IsUsing() || startRecording;
+    if(startRecording && ImGui::IsMouseReleased(ImGuiMouseButton_Left))
+      startRecording = false;
   }
 }
diff --git a/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.h b/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.h
index 2565575f..fd847335 100644
--- a/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.h
+++ b/SHADE_Engine/src/Editor/Gizmos/SHTransformGizmo.h
@@ -37,11 +37,17 @@ namespace SHADE
       UNIVERSAL = TRANSLATE | ROTATE | SCALEU
     };
 
+    void Init();
     void Draw();
     bool isManipulating = false;
+    bool useSnap = false;
     Mode mode = Mode::WORLD;
     Operation operation = Operation::TRANSLATE;
   private:
+    float scaleSnap = 0.25f;
+    float rotationSnap = 1.0f;
+    SHVec3 translationSnap = SHVec3(0.25f, 0.25f, 0.25f);
+    float* snap = nullptr;
     SHTransformComponent* selectedEntityTransformComponent{nullptr};
     SHCameraComponent* editorCamera{nullptr};
   };
diff --git a/SHADE_Engine/src/Editor/SHEditor.cpp b/SHADE_Engine/src/Editor/SHEditor.cpp
index aff1eaad..06fadfee 100644
--- a/SHADE_Engine/src/Editor/SHEditor.cpp
+++ b/SHADE_Engine/src/Editor/SHEditor.cpp
@@ -92,6 +92,7 @@ namespace SHADE
     SHEditorWindowManager::CreateEditorWindow<SHHierarchyPanel>();
     SHEditorWindowManager::CreateEditorWindow<SHEditorInspector>();
     SHEditorWindowManager::CreateEditorWindow<SHEditorProfiler>();
+    SHEditorWindowManager::CreateEditorWindow<SHAssetBrowser>();
     SHEditorWindowManager::CreateEditorWindow<SHEditorViewport>();
 
     io = &ImGui::GetIO();
@@ -134,7 +135,7 @@ namespace SHADE
       }
     }
     
-    PollPicking();
+    //PollPicking();
 
     if(ImGui::IsKeyDown(ImGuiKey_LeftShift) && ImGui::IsKeyDown(ImGuiKey_LeftCtrl) && ImGui::IsKeyReleased(ImGuiKey_Z))
     {
